<?php
header('Expires: ' . gmdate('D, d M Y H:i:s', time()+(60*60*12)) . ' GMT');
header('Content-Type: text/html; charset=utf-8');
echo '<?xml version="1.0" encoding="utf-8"?>'."\n";
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <title>Full-Text RSS | fivefilters.org</title>
	<link rel="stylesheet" href="js/validationEngine.jquery.css" type="text/css" media="screen" />
	<script type="text/javascript" src="js/jquery-1.3.2.min.js"></script>
	<script type="text/javascript" src="js/jquery.validationEngine-en.js"></script>
	<script type="text/javascript" src="js/jquery.validationEngine.js"></script>

	<style type="text/css">
	body {
		background: #fff url(images/background.png) no-repeat top left;
		font-family: sans-serif;
		margin-left: 3em;
		margin-right: 8em;
		font-size: 100%;
		line-height: 1.4em;
	}
	h1#title { margin-bottom: 0; }
	h1 a { border-bottom: none !important;}
	#content h1 { margin-left: .1em; }
	#menu { margin-left: 10px; }
	#menu a {
		background-color: #000;
		color: #fff;
		padding: 5px;
		margin-right: 1px;
		border-bottom: none;
	}
	a:link {
		color: #000;
		border-bottom: 1px dotted #888;
		text-decoration: none;
	}
	a:visited {
		color: #000;
		border-bottom: 1px dotted #888;
		text-decoration: none;
	}
	a:hover {
		color: #000;
		border-bottom: 1px solid #333;
	}
	h1#title a {
		background: transparent url(images/title.png) no-repeat top left;
		text-indent: -9999px;
		height: 70px;
		display: block;
	}
	p { line-height: 1.5em; }
	h2 { font-size: 1.5em; margin-bottom: .5em; margin-top: 1.5em; }
	h4 { margin-bottom: 0; font-weight: normal; }
	#form { margin-bottom: 1.5em; }
	#content { width: 700px; margin-left: 2em; margin-top: 2em; }
	label { display: block; margin: .2em; cursor:pointer; }
    #url { font-size: 1.2em; padding: 5px; width: 503px; display: block; background-color: #e6f3d7; margin: 0; color: #666; font-family: monospace; letter-spacing: -1px; }
	#url:focus, #url.focused { color: #333; }
    #submit { 
		font-size: 1em;
		cursor:pointer; 
		background: #405927 url(images/icon_feed.png) no-repeat scroll 5px center;
		padding: 0.5em .5em .5em 36px;
		font-weight: bold; 
		-moz-border-radius: 0 0 15px 15px; 
		width: 516px; 
		text-align: left; 
		color: #fff; 
		border: 0; 
		margin: 0;
		-webkit-border-top-left-radius: 0;
		-webkit-border-top-right-radius: 0;
		-webkit-border-bottom-left-radius: 15px;
		-webkit-border-bottom-right-radius: 15px;
	}
    /* #submit:hover { border: 1px solid #999; color: #fff; background-color: #666; } */
	#footer { font-size: .8em; margin-top: 2em; }
	table#compare { font-size: .8em; border-spacing: 1px; width: 500px; }
	#compare thead { background-color: #ddd; }
	#compare th, #compare td { padding: .5em; text-align: left; }
	img { border: 0; }
	.donate th { font-size: .8em; text-align: right; }
    .donate td, .donate th { padding-bottom: .8em; padding-right: .2em; }
	.donate-button {
		background-color: #eee;
		border: 1px solid #666;
		font-size: .8em;
		-moz-border-radius: .2em;
		padding: .2em;
		cursor: pointer;
	}
	.donate-button:hover {
		background-color: lightyellow;
		border: 1px solid red;
	}
	kbd {
		border-style: solid;
		border-width: 1px 2px 2px 1px;
		padding: 0 3px;
	}
	#advanced {
		width: 506px;
		padding: 2px 5px;
		margin: 0;
		border-top: 0;
		border-bottom: 0;
		background-color: #7AA61C;
	}
	#toggle-advanced {
		cursor: pointer;
		width: 506px;
		padding: 2px 5px;
		margin: 0;
		border-top: 0;
		border-bottom: 0;
		background-color: #7AA61C;
		dispdlay: none;
	}
	.alt-feeds { margin-top: .3em; }
	.alt-feeds a {
		background-color: #eee;
		padding: .2em;
	}
	</style>
	<script type="text/javascript">
	$(document).ready(function() {
		$('#advanced').hide();
		$('#toggle-advanced').click(function() {
			if (!$('#advanced').is(':visible')) {
				$('#toggle-advanced label').text('hide options');
				$('#advanced').slideToggle('fast');
			} else {
				$('#toggle-advanced label').text('show more options...');
				$('#advanced').slideToggle('fast', function() {
				});
			}
		});
		// label + input field 
		$('input[title]').each(function() {
			if($(this).val() === '') {
				$(this).val($(this).attr('title'));
			}

			$(this).focus(function() {
				if($(this).val() === $(this).attr('title')) {
					$(this).val('').addClass('focused');
				}
			});

			$(this).blur(function() {
				if($(this).val() === '') {
					$(this).val($(this).attr('title')).removeClass('focused');
				}
			});
		});
		// validate form
		$("#form").validationEngine({scroll:false, inlineValidation:false});

	});
	</script>
  </head>
  <body>
	<div id="header">
		<h1 id="title"><a href="http://fivefilters.org">fivefilters.org</a></h1>
		<div id="menu">
		<a href="../explore_independent_media.php">explore independent media</a><a href="../pdf-newspaper">pdf newspaper</a><a href="../content-only">full-text rss</a><a href="../term-extraction">term extraction</a>
		</div>
	</div>
	<div id="content">
	<h1>Create Full-Text Feeds</h1>
    <form method="get" action="makefulltextfeed.php" id="form">
	<!-- <label for="url">Enter webpage or feed URL</label> -->
	<input type="text" title="Enter webpage or feed URL here" id="url" name="url" class="validate[required,exemptString[Enter webpage or feed URL here]]" />
	<div id="toggle-advanced" class="advanced-bottom"><label>show more options...</label></div>
	<div id="advanced">
		<label>API key: <input type="text" id="key" name="key" /> (<a href="#limits">more information</a>)</label>
		<label>Max items: <select name="max">
							<option value="1">1</option>
							<option value="2">2</option>
							<option value="3">3</option>
							<option value="4" selected="selected">4</option>
							<option value="5">5</option>
							<option value="6">6</option>
							<option value="7">7</option>
							<option value="8">8</option>
							<option value="9">9</option>
							<option value="10">10</option>
							</select> (<a href="#limits">requires API key</a>)</label>
	</div>
	<input type="submit" id="submit" name="submit" value="Create Feed" /> 
	<h4>Or select from one of the feeds below...</h4>
	<div class="alt-feeds">
		<a href="makefulltextfeed.php?url=<?php echo urlencode('http://www.schnews.org.uk/feed.xml'); ?>">Schnews</a>
		<a href="makefulltextfeed.php?url=<?php echo urlencode('http://www.myantiwar.org/feeds/rss/channel_8.xml'); ?>">Medialens</a>
		
	</div>
	</form>
	
	<div id="thanks">
	<h2>Thanks to everyone who donated! :)</h2>
	<p>The next release should be available in the first week of March.</p>
	</div>
	
	<h2>About</h2>
	<p>This is a free software project to help people extract and read full-text web content. It can extract content from a standard HTML page and return a 1-item feed or it can transform an existing feed into a full-text feed. It is being developed as part of the <a href="http://fivefilters.org">Five Filters</a> project to promote alternative, non-corporate media.</p>
	
<!-- AddThis Button BEGIN -->
<script type="text/javascript">var addthis_pub="k1mk1m";</script>
<a style="border-bottom: none;" href="http://www.addthis.com/bookmark.php?v=20" onmouseover="return addthis_open(this, '', '[URL]', '[TITLE]')" onmouseout="addthis_close()" onclick="return addthis_sendto()"><img src="http://s7.addthis.com/static/btn/lg-share-en.gif" width="125" height="16" alt="Bookmark and Share" style="border:0"/></a><script type="text/javascript" src="http://s7.addthis.com/js/200/addthis_widget.js"></script>
<!-- AddThis Button END -->

	
	<h2>Bookmarklet</h2>
	<p>To easily transform partial-feeds you encounter (or convert any content on a page into a 1-item feed), drag the link below to your browser's bookmarks toolbar.
	Then whenever you'd like a full-text feed, click the bookmarklet.</p>
	<p>Drag this: <a href="javascript:location.href='http://<?php echo $_SERVER['HTTP_HOST'].rtrim($_SERVER['REQUEST_URI'], '/'); ?>/makefulltextfeed.php?url='+escape(document.location.href);" title="test">Full-Text RSS</a></p>
	
	<!--
	<h2>Similar Services</h2>
	
	<p>Tom at <a href="http://echodittolabs.org">EchoDitto Labs</a> had a <a href="http://echodittolabs.org/fulltextrss">similar idea</a> a few years ago. I've tested that service but I think a full-text feed is only returned when the supplied feed has a summary or description of some kind. You can compare results with the following links.</p>
		<table id="compare">
		<thead>
			<tr><th></th><th>FiveFilters.org</th><th>EchoDitto Labs</th></tr>
		</thead>
		<tr>
				<th>Output #1: <a href="http://www.schnews.org.uk/feed.xml" style="font-weight: normal;">Schnews original feed</a></th>
				<td><a href="makefulltextfeed.php?url=<?php echo urlencode('http://www.schnews.org.uk/feed.xml'); ?>">full-text RSS</a></td>
				<td><a href="http://echodittolabs.org/projects/fulltextrss/?url=<?php echo urlencode('http://www.schnews.org.uk/feed.xml'); ?>">full-text RSS</a></td>
			</tr>
			<tr>
				<th>Output #2: <a href="http://www.myantiwar.org/feeds/rss/channel_8.xml" style="font-weight: normal;">Medialens original feed</a></th>
				<td><a href="makefulltextfeed.php?url=<?php echo urlencode('http://www.myantiwar.org/feeds/rss/channel_8.xml'); ?>">full-text RSS</a></td>
				<td><a href="http://echodittolabs.org/projects/fulltextrss/?url=<?php echo urlencode('http://www.myantiwar.org/feeds/rss/channel_8.xml'); ?>">full-text RSS</a></td>
				</tr></table>
	-->

	<h2>API</h2>
	<p>To extract content from a web page or to transform an existing partial feed to full text, pass the URL (<a href="http://meyerweb.com/eric/tools/dencoder/">encoded</a>) in the querystring to the following URL:</p>
	<ul>
		<li style="font-family: monospace;">http://fivefilters.org/content-only/makefulltextfeed.php?url=<strong>[url]</strong></li>
	</ul>
	<p>If you have an API key, add that to the querystring:</p>
	<ul>
		<li style="font-family: monospace; white-space:nowrap;">http://fivefilters.org/content-only/makefulltextfeed.php?key=<strong>[key]</strong>&amp;url=<strong>[url]</strong></li>
		<li style="font-family: monospace; white-space:nowrap;">http://fivefilters.org/content-only/makefulltextfeed.php?key=<strong>[key]</strong>&amp;max=<strong>[number of feed items]</strong>&amp;url=<strong>[url]</strong></li>
	</ul>
	
	<h2 id="limits">Web Service Limits: Free and Paid Modes</h2>
	<p>We have imposed certain limits to keep the service running smoothly and to avoid abuse:</p>
	<table id="compare">
	<thead>
		<tr><th></th><th>Free</th><th><a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=8864339">$10/month</a></th></tr>
	</thead>
	<tr>
		<th>RSS items retrieved</th>
		<td>4</td>
		<td>1-10</td>
	</tr>
	<tr>
		<th>Cache time</th>
		<td>20 minutes</td>
		<td>10 minutes</td>
	</tr>
	<tr>
		<th>Link to fivefilters.org</th>
		<td>Yes</td>
		<td>No</td>
	</tr>
	</table>
	
	<!--<ul>
		<li>The service only returns full text content for the first 5 RSS items in each feed</li>
		<li>Feeds are cached for 20 minutes</li>
		<li>Under each entry there is a link to fivefilters.org</li>
	</ul> -->
	<p>If you don't like the limits associated with the free service, you can either download the source code and host it 
	yourself (see below) or <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=8864339"><strong>buy an API key</strong></a> for $10 a month.</p>
	
	<h2>Source Code and Technologies</h2>
	<p><a href="https://code.launchpad.net/~keyvan-k1m/fivefilters/content-only">Source code available on launchpad.net</a>.<br />The application uses PHP, <a href="http://lab.arc90.com/2009/03/readability.php">Readability</a>, <a href="http://simplepie.org/">SimplePie</a> and <a href="http://www.ajaxray.com/blog/2008/03/08/php-universal-feed-generator-supports-rss-10-rss-20-and-atom/">FeedWriter</a>. Readability is the magic algorithm that identifies and extracts the content.</p>

	<h2>System Requirements</h2>
	
	<p>PHP 5.2.x is required (PHP 5.3 is not yet supported - support is planned for the next release). 
	The code has been tested on a <a href="https://www.nearlyfreespeech.net/">NearlyFreeSpeech.NET</a> account and 
	on Dreamhost. It should also work with other hosts. It has also been tested on Windows 
	using <a href="http://www.wampserver.com/en/index.php">WampServer</a>.</p>
	
	<p>The instructions below will install the code in a folder called 'full-text-rss'. The instructions have been tested on a 
	NearlyFreeSpeech account but should work on other hosts which offer shell access and have the 
	<a href="http://bazaar-vcs.org/">Bazaar</a> client installed.</p>	
	
	<h2>Download and Installation</h2>
	<p>The software can be downloaded completely free through launchpad.net using a Bazaar client (see below). However, many 
	people have been in touch saying they're unable to follow the instructions
	or unwilling to install the Bazaar application required for the download. 
	For those of you who'd like a simpler solution, you can now buy a zip package with the 
	source code for $10 - you will receive an email with download instructions automatically. 
	The zip file contains a readme file with instructions for uploading the code to your web host via FTP.
	
	<form action="https://www.paypal.com/cgi-bin/webscr" method="post">
	<input type="hidden" name="cmd" value="_s-xclick">
	<input type="hidden" name="hosted_button_id" value="B7J77VM6PH7QE">
	<input type="image" src="https://www.paypal.com/en_GB/i/btn/btn_buynow_LG.gif" border="0" name="submit" alt="PayPal - The safer, easier way to pay online.">
	<img alt="" border="0" src="https://www.paypal.com/en_GB/i/scr/pixel.gif" width="1" height="1">
	</form>
	</p>
	
	<h3>Installation with the Bazaar client</h3>
	
	<ol style="width: 800px">
		<li>Log in to your host using SSH</li>
		<li>Change to the directory where you want Full-Text RSS installed</li>
		<li>Enter <kbd>bzr co http://bazaar.launchpad.net/~keyvan-k1m/fivefilters/content-only/ full-text-rss</kbd></li>
		<li>Now enter <kbd>chmod 777 full-text-rss/cache/</kbd></li>
		<li><strong>That's it!</strong> Try accessing the full-text-rss folder through your web browser, you should see the form asking for a URL.</li>
		<li>(Optional) If you'd like to customise the software, rename config-sample.php to config.php and edit the file.</li>
	</ol>
	
	<p>If you'd like to create a feed without going through the form first, you can simply pass the URL in the query string to makefulltextfeed.php. For example:<br /><tt>http://example.org/full-text-rss/makefulltextfeed.php?feed=http://example.org/feed</tt></p>
	
	<h2>Support</h2>
	<p>I'm happy to help activists/anarchists/progressives set this up on their servers. For anyone else, please email for paid support.</p>
	<p><a href="https://bugs.launchpad.net/fivefilters">Bug reports</a> and <a href="https://answers.launchpad.net/fivefilters">questions</a> welcome.</p>
	
	<h2>License</h2>
	<p><a href="http://en.wikipedia.org/wiki/Affero_General_Public_License" style="border-bottom: none;"><img src="images/agplv3.png" /></a><br />This web application is licensed under the <a href="http://en.wikipedia.org/wiki/Affero_General_Public_License">AGPL version 3</a> (<a href="http://www.clipperz.com/users/marco/blog/2008/05/30/freedom_and_privacy_cloud_call_action">find out why</a>). The bulk of the work, however, is carried out by libraries which are licensed as follows...</p>
	<ul>
		<li>Readability: <a href="http://www.apache.org/licenses/LICENSE-2.0">Apache License, Version 2.0</a></li>
		<li>SimplePie: <a href="http://en.wikipedia.org/wiki/BSD_license">BSD</a></li>
		<li>FeedWriter: <a href="http://www.gnu.org/licenses/old-licenses/gpl-2.0.html">GPL</a></li>
	</ul>
	
	<h2 id="donate">Donate</h2>
	<p>The Full-Text RSS service has turned out to be very popular. I would love to continue working on it but will need users
	to support the development. Please <a href="http://www.chipin.com/contribute/id/17c02430b8031b97">donate</a> if you can. This project currently relies on financial support from individual donors, API key holders 
	and a <a href="http://www.webhostingsearch.com">web hosting</a> reviews site.</p>
	<p><strong>Note:</strong> Thanks to everyone who contributed to the last fundraising drive. Version 1.0 has now been released!</p>
	
	<!-- <p>Currently the code that runs the service is more up-to-date and handles different character-encodings
	better than the code in the repository. It is also, however, in need of cleaning up and a little more testing before I can release it.
	I'm trying to raise $200 to allow me to make the necessary changes. Once the $200 target is reached I will begin work on the changes
	and release the code.  The bar below updates automatically when a donation is made and shows how close I am to the goal.</p>
	<p><strong>Note:</strong> During fundraising drives I will occasionally draw attention to these donation pleas by inserting links
	into the RSS feed produced by the free, hosted service. I don't like doing that, but the fact that this is a web service means very few people return to this page once
	they've integrated the service.</p> -->
	
	<!-- <object width="350" height="250"><param name="movie" value="http://widget.chipin.com/widget/id/afd99440da86248b"></param><param name="allowScriptAccess" value="always"></param><param name="wmode" value="transparent"></param><param name="event_title" value="Donate%20to%20Full-Text%20RSS"></param><param name="event_desc" value="Please%20donate%20so%20we%20can%20update%20and%20release%20the%20latest%20version%20of%20the%20code.%20Once%20the%20target%20has%20been%20reached%2C%20we%20will%20begin%20to%20make%20the%20necessary%20changes%20and%20release%20the%20code."></param><embed src="http://widget.chipin.com/widget/id/afd99440da86248b" flashVars="event_title=Donate%20to%20Full-Text%20RSS&event_desc=Please%20donate%20so%20we%20can%20update%20and%20release%20the%20latest%20version%20of%20the%20code.%20Once%20the%20target%20has%20been%20reached%2C%20we%20will%20begin%20to%20make%20the%20necessary%20changes%20and%20release%20the%20code." type="application/x-shockwave-flash" allowScriptAccess="always" wmode="transparent" width="350" height="250"></embed></object> -->
	
	<h2>Author</h2>
	<p>Created by <a href="http://www.keyvan.net">Keyvan Minoukadeh</a> for the <a href="http://fivefilters.org">Five Filters</a> project.<br />
	Email: keyvan (at) keyvan.net</p>
	
	</div>
  </body>
</html>